'1.   Titel blok
'*****************************
'Auteur     Rien van Harmelen
'Datum      juni 2011
'File naam  Basisprogramma
'
'2.   Programma beschrijving.
'***************************
'Het basisprogramma is het vaste deel
'van de Bascomprogramma's 1 t/m 39
'beschreven in het fischertechnik lustrumboek 2011
'
'3.   Compiler gegevens
'**********************
$regfile = "m8def.dat"
$crystal = 16000000
'$baud = 9600
'
'4.   Declaraties
'****************
Declare Sub Motor1dir(byval M1dir As Byte)
Declare Sub Motor3dir(byval M3dir As Byte)
Declare Sub Motor1speed(byval M1speed As Integer)
Declare Sub Motor3speed(byval M3speed As Integer)
'
Declare Sub Motor1_links
Declare Sub Motor1_rechts
Declare Sub Motor1_stop
Declare Sub Motor1_noodstop
'
Declare Sub Motor3_down
Declare Sub Motor3_up
Declare Sub Motor3_stop
Declare Sub Motor3_noodstop
'
Declare Sub Keypressed
Config Debounce = 20
'
'5    Timer0 instellen  tbv initialisatielamp
'********************************************
Config Timer0 = Timer , Prescale = 1024
On Timer0 Ontimer0
Enable Interrupts
Enable Timer0
Start Timer0
Dim Wachttijd As Byte
Wachttijd = 30
'
'6    Congfigureren  I2C-LCD poorten
'***********************************
$lib "Lcd_i2c.lib"                                          '
Config I2cdelay = 1
Const Pcf8574_lcd = &H40
Config Scl = Portd.0
Config Sda = Portd.1
Dim _lcd_e As Byte
_lcd_e = 192
Config Lcd = 16 * 2
'
Cls
Cursor Off
'
Locate 1 , 1
Lcd "Basisprogramma"
'
'7    Configureren Motorpoorten (M1 en M3)
'*****************************************
'Motor M1
'--------
Config Portb.1 = Output
Config Portb.0 = Output
Config Portb.5 = Output

'Motor M3
'--------
Config Portb.2 = Output
Config Portd.6 = Output
Config Portd.7 = Output

Const Fwd = 1
Const Rwd = 2
Const Free = 4
Const Brake = 3
Dim Speed As Integer
Speed = 1023
'
'8    Timer1 instellen tbv PWM
'*****************************
Config Timer1 = Pwm , Pwm = 10 , Prescale = 1 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Up
'
'9.   Configureren Schakelaarpoorten (E1,E3,E4,E5 en E6)
'*******************************************************
Config Pinc.0 = Input
Portc.0 = 0
E6 Alias Pinc.0
'
Config Pinc.2 = Input
Portc.2 = 0
E5 Alias Pinc.2

Config Pinc.3 = Input
Portc.3 = 0
E4 Alias Pinc.3
'
Config Pinc.4 = Input
Portc.4 = 0
E3 Alias Pinc.4
'
Config Pinc.5 = Input
Portc.5 = 0
E1 Alias Pinc.5
'
'10   Configureren Endcoderpoort(schakelaar E2)
'**********************************************
Config Pind.3 = Input
Portd.3 = 0
On Int1 Int1_isr
Enable Int1
Enable Interrupts
Config Int1 = Falling
Sreg.7 = 1
'
Dim E2_count As Integer
E2_count = 0
'
'11   Configureren Initialisatielamppoort (M4) (work-in-proces lamp)
'*******************************************************************
Config Portb.4 = Output
M4 Alias Portb.4
'
'12   Configureren Puntlasserlamppoort (M2)
'******************************************
Config Portb.3 = Output
M2 Alias Portb.3
'
'13   Initialieren variablen
'***************************
'
'Select case
'-----------
Dim Task As Byte
Task = 0
Dim Oldtask As Byte
Oldtask = 0
'
'Softwarematige "wait"
'---------------------
Dim Var As Integer
Var = 0
'
'Aantal lasbeurten
'-----------------
Dim Aantal_keren As Byte
Dim Aantal As Byte
Aantal_keren = 4
Aantal = 0

'Aantal pulsen (schakelaar E2)
'-----------------------------
Dim Puls As Integer
Puls = 0
'
'14.  Timer0 uitschakelen (work-in-proces lamp (=M4)uit)
'*******************************************************
Stop Timer0
'
'15   Programma start hier
'*************************
'
Do

  'Hier komt het eigenlijke programma

Loop
'
'16   Subtroutines motoren
'*************************

'Draairichting motoren (M1 en M3
'-------------------------------
Sub Motor1dir(byval M1dir As Byte )
   If M1dir = 1 Then
      Portb.0 = 0
      Portb.5 = 1
      Elseif M1dir = 2 Then
      Portb.0 = 1
      Portb.5 = 0
      Elseif M1dir = 3 Then
      Portb.0 = 1
      Portb.5 = 1
      Elseif M1dir = 4 Then
      Portb.0 = 0
      Portb.5 = 0
   End If
End Sub
'
Sub Motor3dir(byval M3dir As Byte)
   If M3dir = 1 Then
      Portd.6 = 0
      Portd.7 = 1
      Elseif M3dir = 2 Then
      Portd.6 = 1
      Portd.7 = 0
      Elseif M3dir = 3 Then
      Portd.6 = 1
      Portd.7 = 1
      Elseif M3dir = 4 Then
      Portd.6 = 0
      Portd.7 = 0
   End If
End Sub
'
'Snelheid motoren (M1 en M3)
'---------------------------
Sub Motor1speed(byval M1speed As Integer)
   Pwm1b = M1speed
End Sub
'
Sub Motor3speed(byval M3speed As Integer)
   Pwm1a = M3speed
End Sub
'
'Richting motor M1
'-----------------
Sub Motor1_links
   Call Motor1dir(rwd)
   Call Motor1speed(speed)
End Sub
'
Sub Motor1_rechts
   Call Motor1dir(fwd)
   Call Motor1speed(speed)
End Sub
'
'Stop en noodstop motor M1
'-------------------------
Sub Motor1_stop
   Call Motor1dir(brake)
   Call Motor1speed(0 )
End Sub
'
Sub Motor1_noodstop
   Call Motor1dir(brake)
   Call Motor1speed(0)
   'End
End Sub

'Richting motor M3
'-----------------
Sub Motor3_down
   Call Motor3dir(fwd)
   Call Motor3speed(speed)
End Sub
'
Sub Motor3_up
   Call Motor3dir(rwd)
   Call Motor3speed(speed)
End Sub
'
'Stop en noodstop motor M3
'-------------------------
Sub Motor3_stop
   Call Motor3dir(brake)
   Call Motor3speed(0)
End Sub
'
Sub Motor3_noodstop
   Call Motor3dir(brake)
   Call Motor3speed(0)
   'End
End Sub
'
'17   Subroutine Timer0 tbv M4
'*****************************
Ontimer0:
    Wachttijd = Wachttijd - 1
    If Wachttijd < 1 Then
      Toggle M4
      Wachttijd = 30
    End If
Return
'
'18   Interrupt subroutine tbv E2_count
'**************************************
Int1_isr:
   Debounce Pind.3 , 0 , Keypressed , Sub
Return

Sub Keypressed
   Incr E2_count
End Sub