'******************
'Opkomstvertraging"
'******************
$regfile = "m8def.dat"
$crystal = 16000000
'$baud = 9600

Declare Sub Motor1dir(byval M1dir As Byte)
Declare Sub Motor3dir(byval M3dir As Byte)
Declare Sub Motor1speed(byval M1speed As Integer)
Declare Sub Motor3speed(byval M3speed As Integer)

Declare Sub Motor1_links
Declare Sub Motor1_rechts
Declare Sub Motor1_stop
Declare Sub Motor1_noodstop

Declare Sub Motor3_down
Declare Sub Motor3_up
Declare Sub Motor3_stop
Declare Sub Motor3_noodstop

Declare Sub Keypressed
Config Debounce = 20

Config Timer0 = Timer , Prescale = 1024
On Timer0 Ontimer0
Enable Interrupts
Enable Timer0
Start Timer0
Dim Wachttijd As Byte
Wachttijd = 30

'I2C LCD
'********
$lib "Lcd_i2c.lib"                                          '
Config I2cdelay = 1
Const Pcf8574_lcd = &H40
Config Scl = Portd.0
Config Sda = Portd.1
Dim _lcd_e As Byte
_lcd_e = 192
Config Lcd = 16 * 2

Cls
Cursor Off

Locate 1 , 1
Lcd "Opkomstvertraging"

'Motoren
'*******
'Motor M1
'Config Portb.1 = Output
Config Portb.0 = Output
Config Portb.5 = Output
'Motor M2
Config Portb.2 = Output
Config Portd.6 = Output
Config Portd.7 = Output

Const Fwd = 1
Const Rwd = 2
Const Free = 4
Const Brake = 3
Dim Speed As Integer
Speed = 1000

Config Timer1 = Pwm , Pwm = 10 , Prescale = 1 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Up

'Schakelaars (E1,E3,E4,E5,E6)
'****************************
Config Pinc.0 = Input
Portc.0 = 0
E6 Alias Pinc.0

Config Pinc.2 = Input
Portc.2 = 0
E5 Alias Pinc.2

Config Pinc.3 = Input
Portc.3 = 0
E4 Alias Pinc.3

Config Pinc.4 = Input
Portc.4 = 0
E3 Alias Pinc.4

Config Pinc.5 = Input
Portc.5 = 0
E1 Alias Pinc.5

'Endcoder (schakelaar E2)
'**********************
Config Pind.3 = Input
Pind.3 = 1
On Int1 Oncount1
Enable Int1
Enable Interrupts
Config Int1 = Falling
'
Dim E2_count As Integer
E2_count = 0

'Initialisatielamp
'*****************
Config Portb.4 = Output
M4 Alias Portb.4

'Puntlasser lamp
'***************
Config Portb.3 = Output
M2 Alias Portb.3

'Select case
'***********
Dim Task As Byte
Task = 0
Dim Oldtask As Byte
Oldtask = 0

'Software matige "wait"
'**********************
Dim Var As Integer
Var = 0

'Aantal lasbeurten
'*****************
Dim Aantal_keren As Byte
Aantal_keren = 0


Stop Timer0

Do
   Select Case Task
      Locate 2 , 1
      Lcd "task = " ; Task

      Case 0:
         If E3 = 1 Then
            Task = 1
            Var = 0
         End If

      Case 1:
         Var = Var + 1
         If Var >= 100 Then
            Task = 2
            Call Motor1_links
         End If

         If E3 = 0 Then Task = 0

      Case 2:
         If E3 = 0 Then
            Task = 0
            Call Motor1_stop
         End If

   End Select
Loop


Sub Motor1dir(byval M1dir As Byte )
   If M1dir = 1 Then
      Portb.0 = 0
      Portb.5 = 1
      Elseif M1dir = 2 Then
      Portb.0 = 1
      Portb.5 = 0
      Elseif M1dir = 3 Then
      Portb.0 = 1
      Portb.5 = 1
      Elseif M1dir = 4 Then
      Portb.0 = 0
      Portb.5 = 0
   End If
End Sub
'
Sub Motor3dir(byval M3dir As Byte)
   If M3dir = 1 Then
      Portd.6 = 0
      Portd.7 = 1
      Elseif M3dir = 2 Then
      Portd.6 = 1
      Portd.7 = 0
      Elseif M3dir = 3 Then
      Portd.6 = 1
      Portd.7 = 1
      Elseif M3dir = 4 Then
      Portd.6 = 0
      Portd.7 = 0
   End If
End Sub
'
Sub Motor1speed(byval M1speed As Integer)
   Pwm1b = M1speed
End Sub

Sub Motor3speed(byval M3speed As Integer)
   Pwm1a = M3speed
End Sub

Sub Motor1_links
   Call Motor1dir(rwd)
   Call Motor1speed(speed)
End Sub

Sub Motor1_rechts
   Call Motor1dir(fwd)
   Call Motor1speed(speed)
End Sub

Sub Motor1_stop
   Call Motor1dir(brake)
   Call Motor1speed(0 )
End Sub

Sub Motor1_noodstop
   Call Motor1dir(brake)
   Call Motor1speed(0)
   End
End Sub

Sub Motor3_down
   Call Motor3dir(fwd)
   Call Motor3speed(speed)
End Sub

Sub Motor3_up
   Call Motor3dir(rwd)
   Call Motor3speed(speed)
End Sub

Sub Motor3_stop
   Call Motor3dir(brake)
   Call Motor3speed(0)
End Sub

Sub Motor3_noodstop
   Call Motor3dir(brake)
   Call Motor3speed(0)
   End
End Sub


Ontimer0:
    Wachttijd = Wachttijd - 1
    If Wachttijd < 1 Then
      Toggle M4
      Wachttijd = 30
    End If
Return

Oncount1:
   Debounce Pind.3 , 1 , Keypressed , Sub
Return

Sub Keypressed
   Incr E2_count
End Sub